#include<bits/stdc++.h>
#define int long long
using namespace std;

const int INF=2e9+1;

int n,k;
vector<int>a;

bool check(int mid)
{
    int cnt=0;

    int cur=0;
    for(int i=0;i<n;i++)
    {
        cur=cur|a[i];
        if((cur&mid)==cur)
        {
            cur=0;
            cnt++;
        }
    }

    return cnt>=k;
}

int32_t main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>k;
    a.resize(n);
    int mx=0;
    for(int i=0;i<n;i++)
    {
        cin>>a[i];
        mx=max(mx,a[i]);
    }

    while(mx>0)
    {
        if(check(mx))
        {
            cout<<mx<<'\n';
            return 0;
        }
        mx--;
    }

    return 0;
}